#! /usr/bin/perl -w

use lib 'mod_perl';
use strict;
use CGI;
use Tex_upgrade;
use Tex_html; # procedury k sestaveni stranky
use Cz::Cstocs;
$CGI::POST_MAX = 10000000;    # velikost ukladanych souboru omezena ma 10MB

my $q    = new CGI;
my $tisk = new Tex_upgrade;

my $filename;
my $exist = 0;
my %labels;

# predame si id uzivatele, jinak nastavime na uzivatele s id=0, tj. default
my $user = ( defined $q->remote_user() ) ? $q->remote_user() : "default";

# nacteni uzivatelskych preferenci
my %pref   = $tisk->nacti($user);
my $prefJS = $tisk->nactiJS($user)
    ;    # preference pro javascript bez obsahu editoru a rovnou v promenne

# $tisk->debug;     # ladici rezim
###
################### Reakce na stisknuta tlacitka ##############################

if ( $q->param('ps') ) {

# pokud bylo stisknuto tlacitko pro preklad PS nastavime tisk do PostScriptu a vytiskneme
    $tisk->set(1);
    $tisk->set_transl( $q->param('preklad') );
    $tisk->set_tex_num( $q->param('pruchod') );
    if ( defined( $q->param('komprim') ) ) {
        $tisk->set_komprim( $q->param('komprim') );
    }
    $tisk->set_user($user);
    if ( $q->param('local') && ( $q->param('uploaded_file') ne '' ) ) {
        $tisk->set_texlocal(1);
        $filename = $q->upload('uploaded_file');
        $tisk->save_local($filename);
    }
    else {
        $tisk->add( $q->param('pole') );
    }
    $tisk->print;
    exit;
}
elsif ( $q->param('pdf') ) {

# pokud bylo stisknuto tlacitko pro preklad PDF nastavime tisk do PDF a vytiskneme
    $tisk->set(2);
    $tisk->set_transl( $q->param('preklad') );
    $tisk->set_tex_num( $q->param('pruchod') );
    if ( defined( $q->param('komprim') ) ) {
        $tisk->set_komprim( $q->param('komprim') );
    }
    $tisk->set_user($user);
    if ( $q->param('local') && ( $q->param('uploaded_file') ne '' ) ) {
        $tisk->set_texlocal(1);
        $filename = $q->upload('uploaded_file');
        $tisk->save_local($filename);
    }
    else {
        $tisk->add( $q->param('pole') );
    }
    $tisk->print;
    exit;
}
elsif ( $q->param('tex') ) {

    # pokud bylo stisknuto tlacitko pro ulozeni zdrojaku
    $tisk->set(3);
    if ( defined( $q->param('komprim') ) ) {
        $tisk->set_komprim( $q->param('komprim') );
    }
    $tisk->set_user($user);
    if ( $q->param('local') && ( $q->param('uploaded_file') ne '' ) ) {
        $tisk->set_texlocal(1);
        $filename = $q->upload('uploaded_file');
        $tisk->save_local($filename);
    }
    else {
        $tisk->add( $q->param('pole') );
    }
    $tisk->print;
    exit;
}
else {

    #if ($q->param('styl_upload')) {
## pokud bylo stisknuto tlacitko pro pridani styloveho souboru
#   $filename = $q->upload('uploaded_file');
#   $tisk->set_user($user);
#   $filename =~ m#([^\\/]+)$#; # v Mozille s cestou v IE bez cesty
#   if ((-e "/jail/$1") || ($q->param('uploaded_file') eq '')) {
#           $exist = 1;     # pokud soubor tohoto jmena jiz existuje, tak ho samozrejme neprepiseme
#   } else {
#       $tisk->save($filename);
#   }
#}

    if ( $q->param('save') ) {

        # pokud bylo stisknuto tlacitko pro ulozeni obsahu editoru na server
        $tisk->set_user($user);
        $tisk->save_file( $q->param('pole'), $q->param('save') );
    }

################################## Sestaveni vlastni stranky ###########################

    # sestaveni hlavicky stranky
    Tex_html::print_http_header($q);
    $tisk->hlavicka('Pracovní plocha');

    print '
    <div id="tools">
	<div class="tools-group">
	    <button class="tools-item icon save-icon" id="btnSave" title="Uložit soubor"></button>
	    <button class="tools-item icon left-arrow-icon" id="btnUndo" title="Zpět"></button>
	    <button class="tools-item icon right-arrow-icon" id="btnRedo" title="Vpřed"></button>
	    <button class="tools-item icon search-icon" id="btnSearch" title="Vyhledávání"></button>
	    <button class="tools-item icon checkmark-icon" id="btnSpellCheck" title="Kontrola pravopisu"></button>
	</div>
	<div class="tools-group">
	    <button class="tools-item" id="btnBold" title="Tučné písmo"><b>B</b></button>
	    <button class="tools-item" id="btnItalic" title="Kurzíva"><i>I</i></button>
	    <button class="tools-item" id="btnSmallCaps" title="Kapitálky">K<span class="small-caps">a</span></button>
	    <button class="tools-item" id="btnTypewriter" title="Strojopis">T</button>
	</div>
	<div class="tools-group">
	    <button class="tools-item icon calendar-icon" id="btnTables" title="Vložit tabulku"></button>
	    <button class="tools-item icon image-icon" id="btnImages" title="Vložit obrázek"></button>
	    <button class="tools-item icon list-icon" id="btnLists" title="Vložit seznam"></button>
	    <button class="tools-item icon style-icon" id="btnStyles" title="Návrhář stylů"></button>
	    <button class="tools-item" id="btnSpaces" title="Nezlomitelné mezery">Mez</button>
	</div>
    </div>
    <div id="editor">
';
    # otevreni souboru
    my $editorContent = $pref{obsah};
    $editorContent =~ s/\\n/\n/g
        ; # nahradime obycejny \n za konec radku (v preferencich uzivatele se konec radku zadava jako \n)

    if ( $q->param('soubor') )

    {
        $editorContent = $tisk->open_file( $q->param('soubor'), $user );
    }

    if ( $q->param('styl') ) {
        $editorContent = $tisk->open_style( $q->param('styl') );
    }

    # Novy editor
    print '
<section>
    <pre id="codeEdit">' . $editorContent . '</pre>
</section>
';

    print '
                <aside id="symboly" class="">
                    <div class="center scrollable">
                        <button id="btn-backslash" class="button aside-button special">\</button>
                        <button id="btn-bracket-left" class="button aside-button special">{</button>
                        <button id="btn-bracket-right" class="button aside-button special">}</button>
                        <button id="btn-percent" class="button aside-button special">%</button>
                        <button id="btn-caret" class="button aside-button special">^</button>
                        <button id="btn-sharp" class="button aside-button special">#</button>
                        <button id="btn-dollar" class="button aside-button special">$</button>
                        <button id="btn-and" class="button aside-button special">&</button>
                        <button id="btn-tilde" class="button aside-button special">~</button>
                        <button id="btn-underscore" class="button aside-button special">_</button>
                    </div>

                    <hr />

                    <div class="center scrollable">
                        <button id="btn-arrow-left" class="button aside-button special">&#8592;</button>
                        <button id="btn-arrow-down" class="button aside-button special">&#8595;</button>
                        <button id="btn-arrow-up" class="button aside-button special">&#8593;</button>
                        <button id="btn-arrow-right" class="button aside-button special">&#8594;</button>
                        <button id="btn-page-up" class="button aside-button special">&#8657;</button>
                        <button id="btn-page-down" class="button aside-button special">&#8659;</button>
                    </div>
                    <hr />
                    <div id="aside-buttons">
                        <div class="buttons aside-button">
                            <a href="#" class="button gray-button" id=log2>log</a>
                        </div>
                        <div class="buttons aside-button" id=PDFta>
                            <a href="#" class="button red-button">PDF</a>
                        </div>
                    </div>
                </aside>
                <aside class="right hidden">
                </aside>
            </div>

            <footer id="statusbar" class="shadow-controls">
                <span id="statusFile">
                    <span id="statusFileChanged">&#9679;</span>
                    <span id="statusFileName"></span>
                </span>
                <span id="statusFileSize"></span>
                <span id="statusFileLastSave"></span>
            </footer>
        </div> <!-- end of #main -->
';

# vytvarime formular obsahujici textovou areu s predpripravenou strukturou LaTeXoveho zdrojaku
    print $q->start_multipart_form(
        { target => 'nactiPreklad', id => 'formular' } );

# editor a jeho naplneni podle oteviraneho souboru, oteviraneho stylu nebo nastaveni obsahu editoru
    if ( $q->param('soubor') ) {

        # dame do promenne obsah souboru, posilame i $user PROC???!!!
        my $open_file = $tisk->open_file( $q->param('soubor'), $user );
        print $q->textarea(
            -name    => 'pole',
            -default => $open_file,
            -rows    => '30',
            -columns => '90',
            -id      => 'pole'
        );
    }
    elsif ( $q->param('styl') ) {
        my $open_style = $tisk->open_style( $q->param('styl') );
        print $q->textarea(
            -name    => 'pole',
            -default => $open_style,
            -rows    => '30',
            -columns => '90',
            -id      => 'pole'
        );
    }
    else {
        $pref{obsah} =~ s/\\n/\n/g;    # nahradime obycejny \n za konec radku
        print $q->textarea(
            -name    => 'pole',
            -default => $pref{obsah},
            -rows    => '30',
            -columns => '90',
            -id      => 'pole'
        );
    }

    print '<div class=hidden>';

    print $q->submit( -name => 'ps', -value => 'PostScript' )
        if ( ( $pref{vystup} eq 'PostScipt' ) or ( $pref{zobraz_vystup} ) );
    print $q->submit( -name => 'pdf', -value => 'PDF', -id => 'btnPDF' )
        if ( ( $pref{vystup} eq 'PDF' ) or ( $pref{zobraz_vystup} ) );

    # pomoci javascriptu si otevreme v novem okne logovy soubor
    print $q->hidden( -name => 'user', -id => 'user', -value => $user );

    # nebo si muze uzivatel ulozit zdrojak napsany do textarea
    print $q->submit(
        -name  => 'tex',
        -value => 'Uložit zdrojový kód',
        -id    => 'save_content_file'
    );

    #print $q->p;

#print "<B>Připojení vlastního souboru:</B>"; print $q->br;
#print $q->filefield('uploaded_file','',50,80);
#print "&nbsp;";
#print $q->submit(-name=>'styl_upload',  -value=>'Připojit');
#print $q->p;
#if ($q->param('styl_upload')) {
#   if ($exist == 1) {
#       print $q->h3("Soubor $filename již existuje nebo je název zadán chybně!");
#   } else {
#       print $q->h3("Připojen soubor $filename.");
#   }
#}
#print $q->checkbox(-name=>'local', -value=>'1', -label=>'Používat lokální soubor');
#print $q->p;

# sestaveni skupiny tlacitek v zavislosti na preferencich
#if ($pref{zobraz_preklad} or $pref{zobraz_pruchod} or $pref{zobraz_komprimaci}) {
#   print "<B>Výběr překladače, počtu průchodů překladače, komprimace výstupu:</B>";
#   print $q->br;
#}

    if ( $pref{zobraz_preklad} ) {
        print $q->popup_menu(
            -name => 'preklad',
            -values =>
                [ 'cslatex', 'csplain', 'latex', 'tex', 'xelatex', 'xetex' ],
            -default => $pref{preklad}
        );
        print "&nbsp;&nbsp;";
    }
    else {
        print $q->hidden( 'preklad', $pref{preklad} );
    }

    if ( $pref{zobraz_pruchod} ) {
        %labels = ( 1, '1 průchod', 2, '2 průchody', 3, '3 průchody' );
        print $q->popup_menu(
            -name    => 'pruchod',
            -values  => [ 1, 2, 3 ],
            -labels  => \%labels,
            -default => $pref{pruchod}
        );
        print "&nbsp;&nbsp;";
    }
    else {
        print $q->hidden( 'pruchod', $pref{pruchod} );
    }

    if ( $pref{zobraz_komprimaci} ) {
        print $q->checkbox(
            -name    => 'komprim',
            -value   => '1',
            -label   => 'Komprimovat výstup?',
            -checked => $pref{komprimace}
        );
    }
    else {
        print $q->hidden( 'komprim', $pref{komprimace} );
    }

    print $q->hidden( -id => 'fullPathSave', -name => 'save', '' );

    # Pridani informaci o otevrenem souboru do skrytych poli formulare
    if ( $q->param('soubor') ) {
        my $char_index = rindex( $q->param('soubor'), '/' );
        my $directory  = '';
        my $file_name  = '';

        if ( $char_index >= 0 ) {
            $file_name = substr( $q->param('soubor'), $char_index + 1 );
            $directory = substr( $q->param('soubor'), 0, $char_index + 1 );
        }
        else {
            $file_name = $q->param('soubor');
        }

        print $q->hidden(
            -id    => 'openFileDir',
            -name  => 'save',
            -value => $directory
        );
        print $q->hidden(
            -id    => 'openFile',
            -name  => 'save',
            -value => $file_name
        );
    }

###################################### Sestaveni konce stranky #######################
    print $q->endform;
    print $q->iframe( { -name => 'nactiPreklad', -id => 'nactiPreklad' },
        "" );

    #print "</div>";
    #print "</div>";

    print '</div>';    #konec hidden

    $tisk->paticka;
}
