package Tex_upgrade;

use lib '/evis/mod_perl';
use CGI;
use strict;
use SuperClass;
use Socket;
use Apache::Htpasswd;
$CGI::POST_MAX = 10000000;    # velikost ukladanych souboru omezena ma 10MB

# co dedime
@Tex_upgrade::ISA = qw(SuperClass);

# verze modulu
$Tex_upgrade::VERSION = '0.05';

# korektne zavedeny modul
# TODO: zjistit proc neni na konci
1;

sub init {
    my $self = shift;

    # ulozeni parametru
    %$self = @_;

    $self->{debug}
        = 0;    # ladici rezim, nachava v /tmp soubory vznikle pri prekladu
    $self->{base_prefix} = '.process.' . time . $$ . '.';
    $self->set_master_prefix('tow');
    $self->{kam}         = 0;    # 1 -- tisk do PS, 2 -- tisk do PDF
    $self->{cim}         = '';   # typ prekladu (cslatex, csplain, latex, tex)
    $self->{komprim}     = 0;    # komprimovat vystupni soubor? Ne
    $self->{texlocal}    = 0;    # Brat lokalni soubor uzivatele? Ne
    $self->{buffer}      = '';   # sem plnime TeXovy zdrojak
    $self->{tex_num}     = 1;    # pocet pruchodu TeXem
    $self->{user}        = 0;    # TeX user id
    $self->{extra_dvips} = '';
    $self->{error}       = 0;
    $self->{log_name}    = '';
    $self->{dir}         = '';

    return $self;
}

#############################
## Nove subroutines
#############################

sub initX {
    my $q      = new CGI;
    my $self   = shift;
    my $nadpis = shift;
    my $user = ( defined $q->remote_user() ) ? $q->remote_user() : "default";
}

sub print_http_header {
	my ($q, @bad) = @_;
    die "Extra args" if @bad;
    print $q->header( -type => 'text/html', -charset => 'UTF-8' );

}


#############################
## Puvodni
#############################

sub hlavicka {
    my $q      = new CGI;
    my $self   = shift;
    my $nadpis = shift;
    my $user = ( defined $q->remote_user() ) ? $q->remote_user() : "default";

    #sestaveni hlavicky stranky

    #print $q->header( -type => 'text/html', -charset => 'UTF-8' );

    print '
<!DOCTYPE html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js"> <!--<![endif]-->
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>TeXonWeb</title>
	<meta name="description" content="">
	<meta content=\'width=device-width, height=device-height, initial-scale=1.0, maximum-scale=1.0, user-scalable=0\' name=\'viewport\' />

	<!-- Place favicon.ico and apple-touch-icon.png in the root directory -->

	<link rel="stylesheet" href="css/normalize.css">
	<link rel="stylesheet" href="css/flaticon.css">
	<link rel="stylesheet" href="css/jquery-ui/jquery-ui.css">
	<link rel="stylesheet" href="css/main.css">
	<link rel="stylesheet" href="css/fontello.css">
	<link rel="stylesheet" href="css/lightbox.css">
	<link rel="stylesheet" href="css/tooltipster.css">
	<link rel="stylesheet" href="css/themes/tooltipster-shadow.css">

	<!--[if IE 7]>
	<link rel="stylesheet" href="css/fontello-ie7.css">
	<![endif]-->
	<script src="js/libs/modernizr-2.6.2.min.js"></script>
';

    if ( $user ne "default" ) {

        # nepripojime JS veci, kdyz nejsme prihlaseni
        print '
	<script type="text/javascript" src="js/libs/jquery.js"></script>
	<script type="text/javascript" src="js/libs/jquery.tinysort.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery-ui.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.ui.touch-punch.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.tooltipster.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.flash-message.js"></script>
	<script type="text/javascript" src="js/libs/handlebars.min.js"></script>
	<script type="text/javascript" src="js/libs/lightbox.min.js"></script>
	<script type="text/javascript" src="js/main.js"></script>
	<!-- <script onload="isSocketIOloaded=true;" type="text/javascript" src="https://tex.mendelu.cz:3000/socket.io/socket.io.js"></script> -->';

#print '<script type="text/javascript" src="js/libs/jquery-migrate-1.2.1.js"></script>';
        print '
	<script type="text/javascript" src="js/tools_panel.js"></script>
	<script type="text/javascript" src="js/settings_panel.js"></script>
	<script type="text/javascript" src="js/aside_left.js"></script>
	<script type="text/javascript" src="js/aside_right.js"></script>
    <script type="text/javascript" src="js/statusbar.js"></script>
    <script type="text/javascript" src="js/styles_parser.js"></script>
    <script type="text/javascript" src="js/styles_designer.js"></script>
	<script type="text/javascript" src="js/translate/cs.js"></script>
	<script type="text/javascript" src="js/spravce_souboru.js"></script>
	<script type="text/javascript" src="js/sdileni_dokumentu.js"></script>
	<script type="text/javascript" src="js/spravce_verzi.js"></script>
	<script type="text/javascript" src="js/navrhar_tabulek.js"></script>
	<script type="text/javascript" src="js/navrhar_seznamu.js"></script>
	<script type="text/javascript" src="js/vkladani_obrazku.js"></script>
	<script type="text/javascript" src="js/pravopis.js"></script>
	<script type="text/javascript" src="js/help.js"></script>
	<script type="text/javascript" src="js/sablony.js"></script>';
    }
    else {
# JS veci pripojime i pro neprihlasene uzivatele, aby meli nejakou funkcionalitu
        print '
	<script type="text/javascript" src="js/libs/jquery.js"></script>
	<script type="text/javascript" src="js/libs/jquery.tinysort.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery-ui.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.ui.touch-punch.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.tooltipster.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.flash-message.js"></script>
	<script type="text/javascript" src="js/libs/lightbox.min.js"></script>
	<script type="text/javascript" src="js/libs/handlebars.min.js"></script>
	<script type="text/javascript" src="js/main.js"></script>
	<script type="text/javascript" src="js/tools_panel.js"></script>
	<script type="text/javascript" src="js/settings_panel.js"></script>
	<script type="text/javascript" src="js/aside_left.js"></script>
	<script type="text/javascript" src="js/aside_right.js"></script>
	<script type="text/javascript" src="js/statusbar.js"></script>
    <script type="text/javascript" src="js/styles_parser.js"></script>
    <script type="text/javascript" src="js/styles_designer.js"></script>
	<script type="text/javascript" src="js/translate/cs.js"></script>
	<script type="text/javascript" src="js/spravce_souboru.js"></script>
	<script type="text/javascript" src="js/sdileni_dokumentu.js"></script>
	<script type="text/javascript" src="js/spravce_verzi.js"></script>
	<script type="text/javascript" src="js/navrhar_tabulek.js"></script>
	<script type="text/javascript" src="js/navrhar_seznamu.js"></script>
	<script type="text/javascript" src="js/vkladani_obrazku.js"></script>
	<script type="text/javascript" src="js/pravopis.js"></script>
	<script type="text/javascript" src="js/help.js"></script>
	<script type="text/javascript" src="js/sablony.js"></script>';
    }

    # Test zda prohlizec je zarizeni od Apple (iPad, iPhone, iPod)
    if (   $ENV{'HTTP_USER_AGENT'} =~ /iPad/
        || $ENV{'HTTP_USER_AGENT'} =~ /iPhone/
        || $ENV{'HTTP_USER_AGENT'} =~ /iPod/ )
    {
        print
            '<script type="text/javascript" src="js/appleDevices.js"></script>';
    }

    #print '<style type="text/css">';
    print '
</head>
';

    #print '<body onload="nastav(\'pole\')">';
    print '
<body>
		<!--[if lt IE 7]>
			<p class="browsehappy">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> to improve your experience.</p>
		<![endif]-->

		<!-- DIV pro prekryti a zasednuti cele obrazovky -->
		<div id="overlay"></div>

		<!-- Hlavni obsah -->
		<div id="main">

				<!-- Flash Messages -->
				<div id="flashMessages"></div>

				<!-- Hlavni nabidka -->

				<nav id="sideMenuMain" class="sideMenu" role="navigation">
					<ul>
						<li id="open_file" class="open-file-icon menuItem">Otevřít</li>
						<li id="templates" class="template-icon menuItem">Šablony</li>
						<li id="new_document" class="empty-file-icon menuItem">Nový</li>
						<li id="open_empty_list" class="open-new-list-icon menuItem">Nová karta</li>
						<li id="save_file" class="save-icon menuItem">Uložit</li>
						<li id="save_file_as" class="save-icon menuItem">Uložit jako</li>
						<li id="files" class="filesystem-icon menuItem">Soubory</li>
						<li id="download_content" class="download-icon menuItem">Stáhnout</li>
						<li id="log" class="log-icon menuItem delimiter">log</li>
						<li id="PDF" class="pdf-icon menuItem">PDF</li>
					</ul>
				</nav>

				<!-- Ovladaci menu pro Spravce souboru -->

				<nav id="sideMenuFiles" class="sideMenu" role="navigation">
                                        <ul>
                                                <li id="closeFiles" class="back-arrow-icon menuItem menuItemFiles">Zpět</li>
                                                <li id="loadStyles" class="open-file-icon menuItem menuItemFiles">Nahrát styly</li>
						<li id="save" class="save-icon menuItem menuItemFiles">Uložit</li>
						<li id="file_new_list" class="open-new-list-icon menuItem menuItemFiles">Otevřít v nové kartě</li>
                                                <li id="rename" class="rename-icon menuItem menuItemFiles">Přejmenovat</li>
                                                <li id="move" class="move-icon menuItem menuItemFiles">Přesunout</li>
                                                <li id="copy" class="copy-icon menuItem menuItemFiles">Kopírovat</li>
                                                <li id="paste" class="paste-icon menuItem menuItemFiles">Vložit</li>
						<li id="delete" class="delete-icon menuItem menuItemFiles">Smazat</li>
                                                <li id="create_dir" class="new-icon menuItem menuItemFiles">Nová složka</li>
						<li id="change_encoding" class="encoding-icon menuItem menuItemFiles">Změna kódování</li>
						<li id="share" class="sharing-icon menuItem menuItemFiles">Sdílet</li>
                                                <li id="download" class="download-icon menuItem menuItemFiles">Stáhnout soubor</li>
						<li id="upload" class="upload-icon menuItem menuItemFiles">Nahrát soubor</li>
                                        </ul>
                                </nav>

				<!-- Obsah Spravce souboru !-->

				<div id="fileManager" class="sideContent">
		    				<span id="file_name_box">
							Název souboru: <input id="file_name" type="text" value="">
						</span>

						<table id="xtable">
							<thead>
								<tr>
									<td class="name">Název</td>
									<td class="size">Velikost</td>
									<td class="modify">Změněno</td>
									<td class="enc">Kódování</td>
								</tr>
							</thead>
							<tbody>
							</tbody>
						</table>

						<!-- Pole urcena pro kopirovani/presun -->
						<!-- Pole urcujici zda jde o kopirovani/presun 1 = kopirovani, 0 = presun -->
						<input id="filecopymove" type="hidden" value="">
						<!-- Pole urcujici jmeno kopirovaneho/presouvaneho souboru -->
						<input id="filecopyname" type="hidden" value="">
						<!-- Pole urcujici cestu ke kopirovanemu/presouvanemu souboru -->
						<input id="filecopypath" type="hidden" value="">


						<!-- Pole urcujici rezim spravce souboru -->
						<input id="action" type="hidden" value="">

						<!-- Formular pro upload souboru -->
						<form id="upload_file">
							<input type="file" name="filename" class="hidden" />
							<input type="hidden" name="upload" value="upload" />
							<input type="hidden" name="path" value="" />
						</form>

						<!-- Formular pro download souboru -->
						<form id="download_file">
							<input type="hidden" value="download" name="download">
							<input id="download_path" type="hidden" value="" name="path">
							<input id="download_name" type="hidden" value="" name="filename">
						</form>

						<!-- Odkaz pro preview obrazku -->
						<a id="image_preview" class="hidden" href="" data-lightbox="" data-title=""></a>
		    		</div>

				<!-- Nabidka pro zmenu kodovani -->
                                <div id="menu_encoding">
                                	<span>Zvolte nové kódování souboru.</span>
					<br/>
                                        <select id="select_encoding">
                                        	<option value="UTF-8">UTF-8</option>
                                                <option value="CP1250">CP1250</option>
                                                <option value="ISO-8859-2">ISO-8859-2</option>
                                        </select>
					<br/>
					<a id="close_encoding" class="button gray-button modal-button" href="#">Zavřít</a>
					<a id="submit_encoding" class="button gray-button modal-button" href="#">Změnit</a>
                                </div>

				<!-- Nabidka pro sdileni dokumentu -->
                                <div id="menu_sharing">
                                        <span id="share_instruction">Vyhledejte uživatele, se kterými chcete sdílet dokument</span>
                                        <div id="searching_users">
						<span class="bold">Uživatelské jméno:</span>
						<input id="users_sharing">
                                        </div>
					<div id="selected_users_container">
						<ul id="selected_users">
							<li>test</li>
						</ul>
					</div>
                                        <a id="close_sharing" class="button gray-button modal-button" href="#">Zavřít</a>
                                        <a id="submit_sharing" class="button gray-button modal-button" href="#">Sdílet</a>
					<a id="stop_sharing" class="button gray-button modal-button" href="#">Odebrat sdílení všem</a>
                                </div>


				<!-- Nastaveni -->

				<div id="sideMenuSettings" class="sideMenu">
					<div class="sideMenuBody">
						<table>
							<tr>
								<th><label for="compilation">Překlad:</label></th>
								<td>
									<select name="compilation" id="compilation" class="selectmenu">
										<option value="cslatex">cslatex</option>
	    								<option value="csplain">csplain</option>
	    								<option value="latex">latex</option>
	    								<option value="tex">tex</option>
	    								<option value="xelatex" selected>xelatex</option>
	    								<option value="xetex">xetex</option>
									</select>
								</div>
							</tr>
							<tr>
								<th><label for="compilationsCount">Počet překladů:</label></th>
								<td>
									<div id="compilationsCount">
    									<input type="radio" id="compCount1" name="compilations-count" value="1" checked="checked"><label for="compCount1">1</label>
    									<input type="radio" id="compCount2" name="compilations-count" value="2"><label for="compCount2">2</label>
										<input type="radio" id="compCount3" name="compilations-count" value="3"><label for="compCount3">3</label>
  									</div>
								</td>
							</tr>
							<tr>
	    						<th><label for="inputFontSize">Velikost písma: </label></th>
								<td><input type="text" id="inputFontSize" name="font-size" style="border:0;" readonly /></td>
							</tr>
							<tr>
								<td colspan="2"><div id="fontSizeSlider"></div></td>
							</tr>
							<tr>
								<th><label for="editorTheme">Barevný motiv:</label></th>
								<td>
									<select name="editor-theme" id="editorTheme" class="selectmenu">
										<option value="texonweb">TeXonWeb</option>
	    								<option value="monokai">Monokai</option>
	    								<option value="clouds_midnight">Clouds Midnight</option>
	    								<option value="eclipse">Eclipse</option>
									</select>
								</div>
							</tr>
							<tr>
								<th><label for="editorContent">Výchozí obsah editoru:</label></th>
								<td>
									<a id="btnEditEditorContent" href="#" class="button gray-button side-menu-button">Upravit</a>
								</td>
							</tr>
                            <tr>
                                <th><label for="exitAlert">Před opuštěním upozornit:</label></th>
                                <td>
                                	<div id="exitAlert" class="toggle-button toggle-button-selected" data-toggle="on">
    									<button></button>
									</div>
                                </td>
                            </tr>
						</table>';
    if ( $user ne "default" ) {
        print '';
    }
    print '
					</div>
					<div class="sideMenuFooter">';
					if ($user ne "default") {
						print '<a id="btnSaveSettings" href="#" class="button gray-button side-menu-button">Uložit nastavení</a>';
					}
					print '</div>
				</div>

				<div id="editorContentModal" class="modal">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">Výchozí obsah editoru</div>
							<div class="modal-body">
								<textarea class="form-control" id="editorContent" rows="10"></textarea>
							</div>
							<div class="modal-footer">
								<a href="#" id="btnResetDefaultEditorContent" class="button modal-button gray-button">Nastavit původní</a>
								<a href="#" id="btnCloseEditorContentModal" class="button modal-button gray-button">OK</a>
							</div>
						</div>
					</div>
				</div>


				<!-- Vkladani obrazku -->
				<div id="insertImageModal" class="modal">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">Vložit obrázek</div>
							<div class="modal-body"></div>
							<div class="modal-footer">
								<a href="#" id="btnInsertImage" class="button modal-button gray-button">Vložit</a>
								<a href="#" id="btnCloseImageModal" class="button modal-button gray-button">Zavřít</a>
							</div>
						</div>
					</div>
				</div>


				<!-- Vkladani seznamu -->
				<div id="insertListModal" class="modal-small">
					<div class="modal-dialog-small">
						<div class="modal-content">
							<div class="modal-header">Vložit seznam</div>
							<div class="modal-body center">
								<a href="#" id="btnOrderedList" class="modal-icon ordered-list-icon" title="Vložit číslovaný seznam"></a>
								<a href="#" id="btnUnorderedList" class="modal-icon list-icon" title="Vložit odrážky"></a>
							</div>
							<div class="modal-footer">
								<a href="#" id="btnCloseListModal" class="button modal-button gray-button">Zavřít</a>
							</div>
						</div>
					</div>
				</div>


				<!-- Vkladani tabulek -->
				<div id="insertTableModal" class="modal">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">Vložit tabulku</div>
							<div class="modal-body">
							</div>
							<div class="modal-footer">
								<a href="#" onclick="table_create()" id="btnNextTableModal" class="button modal-button gray-button">Další</a>
								<a href="#" onclick="closeDialog_table(1)" id="btnInsertTableModal" class="button modal-button gray-button" style="display: none;">Vložit</a>
								<a href="#" id="btnCloseTableModal" class="button modal-button gray-button">Zavřít</a>
							</div>
						</div>
					</div>
				</div>


                <!-- Navrhar stylu --!>
				<div id="stylesDesignerModal" class="modal">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">Návrhář stylů</div>
							<div class="modal-body">
							</div>
							<div class="modal-footer">
                                <a href="#" id="btn-save-style" class="button modal-button gray-button">Uložit</a>
                                <a href="#" id="btn-styles-back" class="button modal-button gray-button">Zpět</a>
                                <a href="#" id="btnInsertStyleToEditor" class="button modal-button gray-button">Vložit do editoru</a>';
                                if ($user ne "default") {
                                	print ' <a href="#" id="btnCreateStyleFile" class="button modal-button gray-button">Uložit do souboru</a>';
                            	}
								print ' <a href="#" id="btnCloseStylesModal" class="button modal-button gray-button">Zavřít</a>
							</div>
						</div>
					</div>
				</div>


				<!-- Kontrola pravopisu -->
				<div id="spellCheckModal" class="modal">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">Kontrola pravopisu</div>
							<div class="modal-body">
								<div class="column">
									<input id="currCorrectionText" type="text" name="current-correction" />
									<div id="suggestionsContainer"></div>
								</div>
								<div class="column">
									<input id="btnProcessCorrection" class="button modal-button gray-button" type="button" name="process-correction" value="Nahradit" />
									<input id="btnAddToDictionary" class="button modal-button gray-button" type="button" name="process-correction" value="Naučit" />
									<input id="btnIgnoreWord" class="button modal-button gray-button" type="button" name="process-correction" value="Ignorovat" />
									<input id="btnNextWord" class="button modal-button gray-button" type="button" name="process-correction" value="Další" />
									<input id="btnPreviousWord" class="button modal-button gray-button" type="button" name="process-correction" value="Předchozí" />
								</div>
							</div>
							<div class="modal-footer">
								<a href="#" id="btnCloseSpellCheckModal" class="button modal-button gray-button">Zavřít</a>
							</div>
						</div>
					</div>
				</div>


				<!-- Vypis sablon -->

				<div id="templatesList" class="sideContent">
					<table id="xtable">
                                        	<thead>
                                                	<tr>
                                                        	<td class="name">Název</td>
                                                        </tr>
                                                </thead>
                                                <tbody>
							<tr class="file">
								<td class="ext_sty name" abbr="cestne_prohlaseni_o_zapocitatelne_praxi.tex">Čestné prohlášení o započitatelné praxi</td>
							</tr>
							<tr class="file">
								<td class="ext_sty name" abbr="darovaci_smlouva.tex">Darovací smlouva</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="dohoda_o_pracovni_cinnosti.tex">Dohoda o pracovní činnosti</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="dopis.tex">Dopis</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="hlaseni_zmen_osobnich_udaju.tex">Hlášení změn osobních údajů</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="kalendarA3.tex">Kalendář A3</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="kalendarA4.tex">Kalendář A4</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="cd.tex">Obal na CD</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="dvd.tex">Obal na DVD</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="posudek.tex">Posudek závěrečné práce</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="prezentace_pef.tex">Prezentace PEF</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="vizitky.tex">Vizitky</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="dipp.tex">Závěrečná práce</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="zaznam_o_provozu_vozidla.tex">Záznam o provozu vozidla</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="zadost.tex">Žádost</td>
                                                        </tr>
							<tr class="file">
								<td class="ext_sty name" abbr="zivotopis.tex">Životopis</td>
							</tr>
                                                </tbody>
                                        </table>
				</div>

				<!-- Kontejner pro vypis informativnich zprav uzivateli -->

				<div class="hidden" id="message">
				</div>

			<header id="banner" role="banner">

				<div id="menu-button-holder" class=menu>
					<a href="#" class="button banner-button"></a>
					<!-- <a href="#" class="button banner-button icon-menu"></a> -->
				</div>

				<div id="logo">
					<span class="tex">T<span class="e">E</span>X</span>
					<span class="on">on</span>
					<span class="web">Web</span>
				</div>


				<div id="banner-buttons-holder">';
    if ( $user eq "default" ) {    # neprihlasen
        print '
					<a href="create.pl" class="button banner-button">Registrace</a>
					<a href="auth/" class="button banner-button">Přihlášení</a>
';
    }
    else {                         # prihlasen
        print "
	<a href=\"#\" id=collaborators_list class=\"button banner-button\">Spolupracovníci</a>
	<div id=\"collaboratorsReview\">
                <ul>
                </ul>
        </div>

	<a href=\"#\" id=logged-user data-user=\"$user\" class=\"button banner-button\"><img weight=32 height=32 src=\"../file/icons/user-brown.svg\" /> $user</a>
	<div id=\"userMenu\">
		<ul>
			<li><a href=\"heslo.pl\">Změnit heslo</a></li>
                        <li><a id=logout href=\"\#\">Odhlásit se</a></li>
		</ul>
	</div>
";
    }
    print '
					<a href="https://aurel.mendelu.cz/projects/texonweb/wiki" target="_blank" title="Nápověda" class="button banner-button">?</a>
					<a href="#" id=settings title="Nastavení" class="button banner-button">&nbsp;</a>
				</div>

			</header>
';
}    # konec hlavicky

sub hlavicka_create {
    my $q      = new CGI;
    my $self   = shift;
    my $nadpis = shift;
    my $user = ( defined $q->remote_user() ) ? $q->remote_user() : "default";

    #sestaveni hlavicky stranky

    print $q->header( -type => 'text/html', -charset => 'UTF-8' );

    print '
<!DOCTYPE html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js"> <!--<![endif]-->
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>TeXonWeb</title>
	<meta name="description" content="">
	<meta content=\'width=device-width, height=device-height, initial-scale=1.0, maximum-scale=1.0, user-scalable=0\' name=\'viewport\' />

	<!-- Place favicon.ico and apple-touch-icon.png in the root directory -->

	<link rel="stylesheet" href="css/normalize.css">
	<link rel="stylesheet" href="css/flaticon.css">
	<link rel="stylesheet" href="css/main.css">
	<link rel="stylesheet" href="css/fontello.css">
	<link rel="stylesheet" href="css/animation.css">

	<!--[if IE 7]>
	<link rel="stylesheet" href="css/fontello-ie7.css">
	<![endif]-->
	<script src="js/libs/modernizr-2.6.2.min.js"></script>
';

    if ( $user ne "default" ) {

        # nepripojime JS veci, kdyz nejsme prihlaseni
        print '
	<script type="text/javascript" src="js/libs/jquery.js"></script>
	<script type="text/javascript" src="js/libs/jquery.tinysort.min.js"></script>
	<script type="text/javascript" src="js/libs/jqueryui.js"></script>
	<script type="text/javascript" src="js/libs/jquery.ui.touch-punch.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.cluetip.min.js"></script>';

#print '<script type="text/javascript" src="js/libs/jquery-migrate-1.2.1.js"></script>';
        print '
	<script type="text/javascript" src="js/main.js"></script>
	<script type="text/javascript" src="js/tools_panel.js"></script>
	<script type="text/javascript" src="js/aside_left.js"></script>
	<script type="text/javascript" src="js/aside_right.js"></script>
	<script type="text/javascript" src="js/translate/cs.js"></script>
	<script type="text/javascript" src="js/spravce_souboru.js"></script>
	<script type="text/javascript" src="js/spravce_verzi.js"></script>
	<script type="text/javascript" src="js/navrhar_tabulek.js"></script>
	<script type="text/javascript" src="js/navrhar_seznamu.js"></script>
	<script type="text/javascript" src="js/vkladani_obrazku.js"></script>
	<script type="text/javascript" src="js/pravopis.js"></script>
	<script type="text/javascript" src="js/help.js"></script>
	<script type="text/javascript" src="js/sablony.js"></script>';
    }
    else {
# JS veci pripojime i pro neprihlasene uzivatele, aby meli nejakou funkcionalitu
        print '
	<script type="text/javascript" src="js/libs/jquery.js"></script>
	<script type="text/javascript" src="js/libs/jquery.tinysort.min.js"></script>
	<script type="text/javascript" src="js/libs/jqueryui.js"></script>
	<script type="text/javascript" src="js/libs/jquery.ui.touch-punch.min.js"></script>
	<script type="text/javascript" src="js/libs/jquery.cluetip.min.js"></script>
';
    }

    # Test zda prohlizec je zarizeni od Apple (iPad, iPhone, iPod)
    if (   $ENV{'HTTP_USER_AGENT'} =~ /iPad/
        || $ENV{'HTTP_USER_AGENT'} =~ /iPhone/
        || $ENV{'HTTP_USER_AGENT'} =~ /iPod/ )
    {
        print
            '<script type="text/javascript" src="js/appleDevices.js"></script>';
    }

    print '
</head>
';
    print '
<body>
		<!--[if lt IE 7]>
			<p class="browsehappy">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> to improve your experience.</p>
		<![endif]-->
		<div id="main">

			<header id="banner" role="banner">

				<div id="menu-button-holder" class=back>
					<a href="." class="button banner-button"></a>
				</div>

				<div id="logo">
					<span class="tex">T<span class="e">E</span>X</span>
					<span class="on">on</span>
					<span class="web">Web</span>
				</div>


				<div id="banner-buttons-holder">';
    if ( $user eq "default" ) {    # neprihlasen
        print '
					<a href="auth/" class="button banner-button">Přihlášení</a>
';
    }
    else {
	     		           # prihlasen
        print
            "<a href=\"#\" id=logged-user data-user=\"$user\" class=\"button banner-button\"><img weight=32 height=32 src=\"../file/icons/user-brown.svg\" /> $user</a>";
    }
    print '
					<a href="https://aurel.mendelu.cz/projects/texonweb/wiki" target="_blank" title="Nápověda" class="button banner-button">?</a>
				</div>

			</header>
';
}    # konec hlavicky create

# vytvori stranku s chybovou hlaskou pri nezdarenem prekladu
sub chyba {
    my $q      = new CGI;
    my $self   = shift;
    my $nadpis = shift;

    print $q->header( -type => 'text/html', -charset => 'UTF-8' );
    print '<?xml version="4.0" encoding="UTF-8">';
    print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">';
    print
        '<html xmlns="http://www.w3.org/1999/xhtml" lang="cz" xml:lang="cz"><head><title>TeXonWeb</title>';
    print
        '<meta content="text/html; charset=UTF-8" http-equiv="Content-Type" />';
    print "<script>alert(\"$nadpis\");</script>";
    print '</head>';
    print '<body>';
    print "<p>$nadpis</p>";
    print '</body>';
    print '</html>';

}

sub paticka {
    my $q    = new CGI;
    my $self = shift;

### print "<div id=footer>";
### print "<table width=100%><tr><td width=30%>jprich at pef.mendelu.cz<td width=40% align=center>Optimalizováno pro Firefox<td width=30% align=right>&copy; Jan Přichystal</table>";
### print "</div>";
    # Ace editor
    print "\n";
    print "\n <!-- Ace Editor -->";
    print "\n"
        . '<script src="js/libs/ace/ace.js" type="text/javascript" charset="utf-8"></script>'
        . "\n";
    print "\n";
    print '
		<script>

			ace.require("ace/ext/language_tools");
			var editor = ace.edit("codeEdit");
			editor.setTheme("ace/theme/texonweb");
			editor.getSession().setMode("ace/mode/texonweb");
			editor.getSession().setUseWrapMode(true);
			editor.setOptions({
				enableBasicAutocompletion: true,
				fontFamily: \'monospace\',
				indentedSoftWrap: false
			});
			editor.setShowPrintMargin(false);
			editor.setOptions({fontSize: \'15px\'});
		</script>
';
    print $q->end_html;

}

# nastaveni pracovniho adresare
sub set_dir {
    my $self = shift;
    $self->{dir} = shift;
}

# nastaveni prefixu
sub set_master_prefix {
    my $self          = shift;
    my $master_prefix = shift;
    $self->{prefix} = $master_prefix . $self->{base_prefix};
}

# zjisti zda uzivatel existuje
sub hledej {
    my $self  = shift;
    my $jmeno = shift;

    my ( $u, $h, $id ) = '';
    open( HESLA, "/etc/httpd/passwd" ) or die;
    while (<HESLA>) {
        chomp($_);
        ( $u, $h ) = split( /:/, $_ );
        if ( $u eq $jmeno ) {
            $id = $jmeno;
            last;
        }
    }
    close(HESLA);
    return $id;

}

# vytvori ucet noveho uzivatele
sub vytvor {

    my $self  = shift;
    my $jmeno = shift;
    my $heslo = shift;

    $self->system_log("sudo htpasswd -b /etc/httpd/passwd $jmeno $heslo");

    $self->system_log("mkdir /jail/users/$jmeno");
    $self->system_log(
        "cp /export/tex/www/html/.prefrc /jail/users/$jmeno/.prefrc");

}

# ulozi aktualni nastaveni uzivatele
sub uloz {
    my $self      = shift;
    my $user      = shift;
    my %nastaveni = @_;
    my ( $klic, $hodnota );

    open( NASTAVENI, ">/jail/users/$user/.prefrc" ) or die;
    print( NASTAVENI "# Nastaveni prostredi TeXonWeb uzivatele $user\n" );
    while ( ( $klic, $hodnota ) = each(%nastaveni) ) {
        print( NASTAVENI "$klic = $hodnota\n" );
    }
    close(NASTAVENI);

}

# vrati aktualni nastaveni uzivatele
sub nacti {
    my $self = shift;
    my $user = shift;
    my ( $polozka, $hodnota );
    my %nastaveni;

    open( NASTAVENI, "/jail/users/$user/.prefrc" ) or die;
    while (<NASTAVENI>) {
        chomp($_);
        if ( $_ =~ /^\s*$/ ) {next}
        ;    # vynecham prazdne radky
        if ( $_ =~ /^#/ ) {next}
        ;    # vynecham komentar
        ( $polozka, $hodnota ) = $_ =~ m/^(\w+)\s*=\s*(.*)$/;
        $nastaveni{$polozka} = $hodnota;
    }
    close(NASTAVENI);
    return %nastaveni;
}

# vrati aktualni nastaveni uzivatele pro javascript (vynecha obsah editoru)
sub nactiJS {
    my $self = shift;
    my $user = shift;
    my ( $polozka, $hodnota );
    my %nastaveni;
    my $out;

    open( NASTAVENI, "/jail/users/$user/.prefrc" ) or die;
    while (<NASTAVENI>) {
        chomp($_);
        if ( $_ =~ /^\s*$/ ) {next}
        ;    # vynecham prazdne radky
        if ( $_ =~ /^#/ ) {next}
        ;    # vynecham komentar
        if ( $_ =~ /^obsah/ ) {next}
        ;    # vynecham obsah editoru
        ( $polozka, $hodnota ) = $_ =~ m/^(\w+)\s*=\s*(.*)$/;
        $nastaveni{$polozka} = $hodnota;
    }
    close(NASTAVENI);
    $out = ( join( "::", %nastaveni ) );
    return $out;
}

# vrati seznam obrazku v adresari daneho uzivatele
sub seznam_obr {
    my $self = shift;

    # seznam souboru v adresari uzivatele
    my @soubory = glob
        "/jail/users/$self->{user}/*{jpg,JPG,jpeg,JPEG,png,PNG,gif,GIF,pdf,PDF,eps,EPS}";

    if (@soubory) {

        # vypis obrazku v adresari uzivatele
        foreach (@soubory) {
            s/.*\///;    # vymazeme cestu v nazvech souboru
            $_ = "<option value=\"$_\">$_</option>";
        }
        return @soubory;
    }
    else {
        return "";
    }

}

# nastaveni TeX user id
sub set_user {
    my $self = shift;
    $self->{user} = shift;
}

# nastaveni poctu pruchodu TeXem
sub set_tex_num {
    my $self = shift;
    $self->{tex_num} = shift;
}

# nastaveni poctu pruchodu TeXem
sub set_texlocal {
    my $self = shift;
    $self->{texlocal} = shift;
}

# nastaveni komprimace vystupu
sub set_komprim {
    my $self = shift;
    $self->{komprim} = shift;
}

# ladici rezim
sub debug {
    my $self = shift;
    ++$self->{debug};
}

# plni tiskovy buffer
sub add {
    my $self = shift;

    $self->{buffer} .= join '', @_;

}

# plni tiskovy buffer na zacatek
sub add_begin {
    my $self = shift;

    $self->{buffer} = join( '', @_ ) . $self->{buffer};
}

# nahradi specialni znaky, aby sly prohnat LaTeXem
sub nahrad {

    my $self  = shift;
    my $kopie = shift;

    for (qw (@ _ & ~ %)) {
        $kopie =~ s/$_/\\$_/g;
    }
    $kopie =~ s'\$'\\$'g;

    return $kopie;

}

sub set {

    # nastavi, na kterou tiskarnu se bude tisknout
    my $self = shift;
    if ( defined $self ) {
        $self->{kam} = shift;
    }
}

sub set_transl {

    # nastavi, ktery prekladac se pouzije
    my $self = shift;
    if ( defined $self ) {
        $self->{cim} = shift;
    }
}

sub save {

    # ulozi soubor dany parametrem do adresare /jail
    my $self     = shift;
    my $filename = shift;

    $filename =~ m/^.*\\(.*)/;
    my $bytesread;
    my $buffer;

    # ulozime stylovy soubor do adresare, kde se bude provade preklad TeXem
    open( OUTFILE, ">/jail/users/$self->{user}/$1" );
    while ( $bytesread = read( $filename, $buffer, 1024 ) ) {
        print OUTFILE $buffer;
    }
    close OUTFILE;
}

sub upload {

    # ulozi soubor dany parametrem do adresare /jail
    my $self     = shift;
    my $filename = shift;
    my $path     = shift;

    $filename =~ m/^.*\\(.*)/;
    if ( ( $path eq "" ) or ( $filename eq "" ) )
    {    # pokud parametry jsou prazdne
        $self->chyba("Soubor nelze nahrát na server.");
        return 0;
    }
    else {
        my $bytesread;
        my $buffer;

        # ulozime soubor do adresare pod jmenem urcenym parametrem
        open( OUTFILE, ">$path$filename" ) or die return 0;
        binmode OUTFILE;
        while ( $bytesread = read( $filename, $buffer, 1024 ) ) {
            print OUTFILE $buffer;
        }
        close OUTFILE;
        return 1;
    }
}

sub save_buffer {
    my $self = shift;
    if ( open BUFFER, ">/jail/users/$self->{user}/$self->{prefix}tex" ) {

        #	print BUFFER "\\nonstopmode\n";
        print BUFFER "\\batchmode\n";    # zmena kvuli visicim procesum
        print BUFFER $self->{buffer} . "\n";
        close BUFFER;
    }
}

sub save_local {

    # ulozi soubor dany parametrem do adresare /jail/users...
    my $self     = shift;
    my $filename = shift;

    my $bytesread;
    my $buffer;

    # ulozime stylovy soubor do adresare, kde se bude provade preklad TeXem
    open( OUTFILE, ">/jail/users/$self->{user}/$self->{prefix}tex" );

    # print OUTFILE "\\nonstopmode\n";
    print OUTFILE "\\batchmode\n";
    while ( $bytesread = read( $filename, $buffer, 1024 ) ) {
        print OUTFILE $buffer;
    }
    close OUTFILE;
}

sub save_file {

    # ulozi obsah okna editoru do souboru
    my $self     = shift;
    my $pole     = shift;
    my $filename = shift;

    open( OUTFILE, ">/jail/users/$self->{user}/$filename" );
    print OUTFILE $pole;
    close OUTFILE;
}

# vyprazdni buffer
sub clear {
    my $self = shift;

    $self->{buffer} = '';
}

# otevre soubor v editoru
sub open_file {
    my $self     = shift;
    my $filename = shift;
    my $user     = shift;
    my $error    = 0;

    my $file;
    if ( $filename =~ /\.\./ ) {
        $error = 1;
    }    # nazev souboru nesmi obsahovat ".."

    if ( $error == 0 ) {
        open( FILE, "</jail/users/$user/$filename" ) or $error = 1;
    }
    if ( $error == 0 ) {
        while (<FILE>) {
            $file .= $_;
        }
        close FILE;
        return $file;
    }
    else {
        $self->chyba("Chyba při otevírání souboru. Soubor neexistuje.");
        return "Chyba při otevírání souboru. Soubor neexistuje.";
    }
}

# otevre soubor v editoru
sub open_style {
    my $self     = shift;
    my $filename = shift;

    my $error = 0;

    my $file;
    if ( $filename =~ /\.\./ ) {
        $error = 1;
    }    # nazev souboru nesmi obsahovat ".."

    if ( $error == 0 ) {
        open( FILE, "< styly/$filename" ) or $error = 1;
    }
    if ( $error == 0 ) {
        while (<FILE>) {
            $file .= $_;
        }
        close FILE;
        return $file;
    }
    else {
        $self->chyba("Chyba při otevírání souboru. Soubor neexistuje.");
        return "Chyba při otevírání souboru. Soubor neexistuje.";
    }
}

# sestavi textovy soubor pro ulozeni zdrojaku
sub to_tex {
    my $self = shift;

    $self->save_buffer unless $self->{texlocal};
    if ( $self->{komprim} == 1 ) {
        $self->system_log(
            "cd /jail/users/$self->{user} ; /usr/bin/zip $self->{prefix}zip $self->{prefix}tex"
        );
    }

}

sub to_ps {

    # provede preklad do PostScriptu
    my $self = shift;

    $self->save_buffer unless $self->{texlocal};
    for ( 1 .. $self->{tex_num} ) {
        $self->system_log(
            "sudo /usr/sbin/chroot /jail /bin/nice -n 5 /bin/preloz /usr/local/texlive/2013/bin/x86_64-linux/$self->{cim} /users/$self->{user} $self->{prefix}tex"
        );
    }
    $self->system_log(
        "cd /jail/users/$self->{user}/; /jail/usr/local/texlive/2013/bin/x86_64-linux/dvips $self->{extra_dvips} $self->{prefix}dvi"
    );
    $self->system_log(
        "cp /jail/users/$self->{user}/$self->{prefix}log /export/tex/www/html/tmp/$self->{user}.log"
    );

    if ( $self->{komprim} == 1 ) {
        $self->system_log(
            "cd /jail/users/$self->{user}/ ; /usr/bin/zip $self->{prefix}zip $self->{prefix}ps"
        );
    }
}

sub to_pdf {

    # provede preklad do PDF
    my $self = shift;

    $self->save_buffer unless $self->{texlocal};

    if ( ( $self->{cim} eq "xelatex" ) or ( $self->{cim} eq "xetex" ) ) {

#		$self->system_log("/usr/bin/enconv /jail/users/$self->{user}/$self->{prefix}tex -x UTF-8 --language czech");
        for ( 1 .. $self->{tex_num} ) {
            $self->system_log(
                "sudo /usr/sbin/chroot /jail /bin/nice -n 5 /bin/preloz /usr/local/texlive/2013/bin/x86_64-linux/$self->{cim} /users/$self->{user} $self->{prefix}tex"
            );
        }
    }
    else {
        for ( 1 .. $self->{tex_num} ) {
            $self->system_log(
                "sudo /usr/sbin/chroot /jail /bin/nice -n 5 /bin/preloz /usr/local/texlive/2013/bin/x86_64-linux/pdf$self->{cim} /users/$self->{user} $self->{prefix}tex"
            );
        }
    }
    $self->system_log(
        "cp /jail/users/$self->{user}/$self->{prefix}log /export/tex/www/html/tmp/$self->{user}.log"
    );

    if ( $self->{komprim} == 1 ) {
        $self->system_log(
            "cd /jail/users/$self->{user}/ ; /usr/bin/zip $self->{prefix}zip $self->{prefix}pdf"
        );
    }
}

sub log {

    # generuje logovy soubor pri ladeni
    my $self = shift;
    if ( open LOG, ">>/jail/tmp/tisk.log" ) {
        print LOG join '', @_ if $self->{debug};
        close LOG;
    }
    else { die "error log: $!"; }
}

sub system_log {
    my $self = shift;
    my $cmd  = shift;
    $self->log( "---process: " . $cmd . "\n" );
    if ( open F, $cmd . "|" ) {
        while (<F>) {
            $self->log($_);
        }
        close F;
    }
    else {
        $self->log("...failed start\n");
    }
}

sub print_to_ps {

    # vystupem je PostScriptovy soubor

    my $self = shift;
    $self->to_ps();

    my $output = '';
    if ( $self->{komprim} == 1 ) {
        if ( open F, "/jail/users/$self->{user}/$self->{prefix}zip" ) {
            $output = join '', <F>;
            close F;
        }
    }
    else {
        if ( open F, "/jail/users/$self->{user}/$self->{prefix}ps" ) {
            $output = join '', <F>;
            close F;
        }
    }
    return $output;
}

sub print_to_pdf {

    # vystupem je PDF soubor
    my $self = shift;
    $self->to_pdf();

    my $output = '';
    if ( $self->{komprim} == 1 ) {
        if ( open F, "/jail/users/$self->{user}/$self->{prefix}zip" ) {
            $output = join '', <F>;
            close F;
        }
    }
    else {
        if ( open F, "/jail/users/$self->{user}/$self->{prefix}pdf" ) {
            $output = join '', <F>;
            close F;
        }
    }
    return $output;
}

sub print_to_tex {

    # vystupem je TeX soubor
    my $self = shift;

    $self->to_tex();
    my $output = '';
    if ( $self->{komprim} == 1 ) {
        if ( open F, "/jail/users/$self->{user}/$self->{prefix}zip" ) {
            $output = join '', <F>;
            close F;
        }
    }
    else {
        if ( open F, "/jail/users/$self->{user}/$self->{prefix}tex" ) {
            $output = join '', <F>;
            close F;
        }
    }
    return $output;
}

sub dej_log {
    my $self = shift;

    my $output = '';
    if ( open F, '/jail/tmp/' . $self->{prefix} . 'log' ) {
        $output = join '', <F>;
        close F;
    }
    return $output;

}

sub dej_file {
	# vrati obsah souboru pro AJAX
    my $self = shift;
    my $filename = shift;

    my $output = '';
    if ( open F, $filename ) {
        $output = join '', <F>;
        close F;
    }
    print $output;

}

sub print_log {
    my $q    = new CGI;
    my $self = shift;

#	print $q->header(-type => 'text', -attachment=>'file.log', -design => 'none');
    $q->print( $self->dej_log() );

}

sub print {
    my $q    = new CGI;
    my $self = shift;
    my $ext  = 'ps';
    my $soub;
    my $error = 0;

    if ( $self->{kam} == 1 ) {
        $soub = $self->print_to_ps();
        open( SOUBOR, "/jail/users/$self->{user}/$self->{prefix}ps" )
            or $error = 1;
    }
    elsif ( $self->{kam} == 2 ) {
        $ext  = 'pdf';
        $soub = $self->print_to_pdf();
        open( SOUBOR, "/jail/users/$self->{user}/$self->{prefix}pdf" )
            or $error = 1;
    }
    elsif ( $self->{kam} == 3 ) {
        $ext  = 'tex';
        $soub = $self->print_to_tex();
        open( SOUBOR, "/jail/users/$self->{user}/$self->{prefix}tex" )
            or $error = 1;
    }

    if ( $error == 0 ) {
        while (<SOUBOR>) {
            chomp;
        }
        close SOUBOR;

        if ( $self->{komprim} == 1 ) {
            print $q->header(
                -type       => 'text/x-zip-compressed',
                -design     => 'none',
                -binmode    => 1,
                -attachment => 'file.zip'
            );
        }
        else {
            if ( $self->{kam} == 1 ) {
                print $q->header(
                    -type       => 'application/postscript',
                    -design     => 'none',
                    -binmode    => 1,
                    -attachment => 'file.ps'
                );
            }
            elsif ( $self->{kam} == 2 ) {
                print $q->header(
                    -type       => 'application/pdf',
                    -design     => 'none',
                    -binmode    => 1,
                    -attachment => 'file.pdf'
                );
            }
            elsif ( $self->{kam} == 3 ) {
                print $q->header(
                    -type       => 'text/ascii',
                    -design     => 'none',
                    -binmode    => 1,
                    -attachment => 'file.tex'
                );
            }
        }
        print $soub;
    }
    else {
#	$self->hlavicka('Chyba při překladu');
#	print('Ve vašem dokumentu je chyba. Klikněte na tlačítko Zpět/Back ve Vašem prohlížeči a prohlédněte si logový soubor.');
#	print $q->hr();
#	$error = 0;

        $self->chyba(
            "Ve vašem dokumentu je chyba. Prohlédněte si logový soubor.");
    }

    #return $soubor;

}

sub aspel {
    my $self = shift;
    my $pole = shift;
    my $stat;
    my $soubor;
    my $q = new CGI;

    open( OUTFILE, ">/jail/users/$self->{user}/.file_aspell.tex" );
    print OUTFILE $pole;
    close OUTFILE;

    $stat
        = system(
	# puvodne se seznam preklepu i radil podle abecedy
        # "aspell -l cs -t -p /jail/users/$self->{user}/.aspell.cs.pws list --encoding=utf-8 < /jail/users/$self->{user}/.file_aspell.tex | sort | uniq > /jail/users/$self->{user}/.file_aspell.out"
        "aspell -l cs -t -p /jail/users/$self->{user}/.aspell.cs.pws list --encoding=utf-8 < /jail/users/$self->{user}/.file_aspell.tex > /jail/users/$self->{user}/.file_aspell.out"
        );    # ziskame spatna slova pomoci aspellu
    if ( $stat == 0 and -s "/jail/users/$self->{user}/.file_aspell.out" )
    {         # aspell was succesful and file exists with non-zero length
        open( INFILE, "</jail/users/$self->{user}/.file_aspell.out" );
        while (<INFILE>) {
            chomp $_;
            $soubor .= $_;
            $soubor .= ' ';
        }
        return $soubor;
        close INFILE;

        #		system("/bin/rm -f /jail/users/$self->{user}/file_aspell.tex");
        #		system("/bin/rm -f /jail/users/$self->{user}/file_aspell.out");
    }
    else {
        return "";
    }
}

sub aspel_navrhy {
    my $self  = shift;
    my $slovo = shift;
    my $stat;
    my @navrhy;

    # ziskame navrhy slov od aspellu
    $stat
        = system(
        "echo $slovo | aspell -a -l cs --encoding=utf-8 --suggest | grep \\& | cut -d: -f2 > /jail/users/$self->{user}/.aspell.navrhy"
        );

    if ( $stat == 0 and -s "/jail/users/$self->{user}/.aspell.navrhy" )
    {    # aspell was succesful and file exists with non-zero length
        open( INFILE, "</jail/users/$self->{user}/.aspell.navrhy" );
        while (<INFILE>) {
            chomp $_;
            push( @navrhy, split( /,/, $_ ) );
        }
        foreach (@navrhy) {
            s/\s+(\w+)/$1/
                ; # orezeme nadbytecne mezery na zacatku slov a doplnime html tagy
            $_ = "<option value=\"$_\">$_</option>";
        }

        close INFILE;

        #		system("/bin/rm -f /jail/users/$self->{user}/.aspell.navrhy");
        return @navrhy;
    }

}

sub aspel_pridej {
    my $self  = shift;
    my $slovo = shift;
    my $head  = "personal_ws-1.1 cs 1";
    my $stat;

    if ( -s "/jail/users/$self->{user}/.aspell.cs.pws" )
    {    # pokud je predano slovo a existuje soubor s vlastnim slovnikem
        if ( $slovo ne "" ) {
            $stat = system(
                "echo $slovo >> /jail/users/$self->{user}/.aspell.cs.pws");
        }
    }
    else {
        $stat
            = system("echo $head > /jail/users/$self->{user}/.aspell.cs.pws");
        if ( $slovo ne "" ) {
            $stat = system(
                "echo $slovo >> /jail/users/$self->{user}/.aspell.cs.pws");
        }
    }
}

sub download {
    my $self     = shift;
    my $filename = shift;
    my $q        = new CGI;

    my $output = '';
    if ( open F, $filename ) {
        $output = join '', <F>;
        close F;
    }

    # orezeme vsechno pred nazvem souboru
    $filename =~ s/^.*\/(.*)/$1/;

    # vytiskneme hlavicku a obsah souboru
    print $q->header(
        -type       => 'application/octet-stream',
        -design     => 'none',
        -binmode    => 1,
        -attachment => $filename
    );

    print $output;
}

sub recode {
    my $self     = shift;
    my $filename = shift;
    my $encoding = shift;
    my $stat;

    if (   ( $encoding eq "UTF-8" )
        || ( $encoding eq "ISO-8859-2" )
        || ( $encoding eq "CP1250" ) )
    {
        $stat = system("/usr/bin/enconv -L czech -x $encoding $filename");
    }
    else {
        $stat = -1;
    }

    return $stat;

}

sub copy {
    my $self     = shift;
    my $filename = shift;
    my $path_to  = shift;
    my $stat;

    if ( ( $filename ne "" ) && ( $path_to ne "" ) ) {
        $stat = system("cp $filename $path_to");
    }
    else {
        $stat = -1;
    }
    return $stat;

}

sub saveCopy {
    my $self     = shift;
    my $filename = shift;
    my $newfilename = shift;
    my $stat;

    if ( ( $filename ne "" ) && ( $newfilename ne "" ) ) {
        $stat = system("cp $filename $newfilename");
    }
    else {
        $stat = -1;
    }
    return $stat;
}

sub move {
    my $self     = shift;
    my $filename = shift;
    my $path_to  = shift;
    my $stat;

    if ( ( $filename ne "" ) && ( $path_to ne "" ) ) {
        $stat = system("mv $filename $path_to");
    }
    else {
        $stat = -1;
    }
    return $stat;

}

sub overheslo {
    my $self     = shift;
    my $user     = shift;
    my $password = shift;
    my $ht       = new Apache::Htpasswd(
        { passwdFile => "/etc/httpd/passwd", ReadOnly => 1 } );
    my $stat = 0;

    $stat = $ht->htCheckPassword( $user, $password );
    return $stat;

}

sub zmenheslo {
    my $self     = shift;
    my $user     = shift;
    my $password = shift;

    $self->system_log("sudo htpasswd -b /etc/httpd/passwd $user $password");

}

sub DESTROY {
    my $self = shift;
    system("cd /jail ; /bin/rm -f /jail/users/$self->{user}/$self->{prefix}*")
        unless $self->{debug};

#	system("cd /jail ; /bin/rm -f /jail/$self->{prefix}*") unless $self->{debug};
}

sub getCollaborators {
    my $self     = shift;
    my $user     = shift;
    my $filename = shift;
    my @collaborators;
    my @collaborator;
    my $i = 0;

    open( SHAREFILE, "/jail/users/$user/$filename" ) or die;

    while (<SHAREFILE>) {
        chomp($_);
        if ( $_ =~ /^\s*$/ ) {next;}
        # vynecham prazdne radky
        if ( $_ =~ /^user:/ ) {
	    	@collaborator = split( /:/, $_ );
            	$collaborator[1] =~ s/^\s+|\s+$//g;
            	$collaborators[$i] = $collaborator[1];
            	$i++;
        }
    }

    close(SHAREFILE);
    return @collaborators;
}

sub getPathToShareFile {
    my $self     = shift;
    my $user     = shift;
    my $filename = shift;
    my @path;
    my $pth = "";

    if (-e "/jail/users/$user/.shared/$filename") {
    	open( SHAREFILE, "/jail/users/$user/.shared/$filename" ) or die;

    	while (<SHAREFILE>) {
        	chomp($_);
        	if ( $_ =~ /^\s*$/ ) {next;}
        	# vynecham prazdne radky
        	if ( $_ =~ /^path:/ ) {
                	@path = split( /:/, $_ );
                	$pth  = $path[1];
        	}
    	}

    	close(SHAREFILE);
    } else {
	$pth = "PathNotAvalibale";
    }

    return $pth;
}

sub create_symlinks {
    my $self     = shift;
    my $path     = shift;
    my $filename = shift;
    my $collaborator;

    foreach $collaborator (@_) {
         unlink("/jail/users/$collaborator/$filename");
	 system("ln -s $path$filename /jail/users/$collaborator/$filename");
    }
}

sub modify_symlinks {
    my $self              = shift;
    my $path              = shift;
    my $filename          = shift;
    my $old_collaborators = shift;
    my $new_collaborators = shift;
    my $collaborator;
    my $i = 0;

    while ( $i < $old_collaborators ) {
        $collaborator = shift;
        unlink("/jail/users/$collaborator/$filename");
        $i++;
    }

    $i = 0;

    while ( $i < $new_collaborators ) {
        $collaborator = shift;
        system("ln -s $path$filename /jail/users/$collaborator/$filename");
        $i++;
    }
}

sub delete_symlinks {
    my $self              = shift;
    my $path              = shift;
    my $filename          = shift;
    my $old_collaborators = shift;
    my $collaborator;
    my $i = 0;

    while ( $i < $old_collaborators ) {
        $collaborator = shift;
        unlink("/jail/users/$collaborator/$filename");
        $i++;
    }

    $i = 0;
}

# smaze stare symlinky a vytvori nove podle noveho jmena zdrojoveho souboru
sub rename_symlinks {
    my $self              = shift;
    my $path              = shift;
    my $filename          = shift;
    my $newfilename 	  = shift;
    my $old_collaborators = shift;
    my $collaborator;
    my $i = 0;

    while ( $i < $old_collaborators ) {
        $collaborator = shift;
        unlink("/jail/users/$collaborator/$filename");
	system("ln -s $path$newfilename /jail/users/$collaborator/$newfilename");
        $i++;
    }
}


# odstrani uzivatele ze seznamu spolupracovniku u daneho souboru, daneho vlastnika
sub removeUserFromOwnerList {
    my $self              = shift;
    my $user 		  = shift;
    my $owner             = shift;
    my $share_conf_file   = shift;
    my $new_list 	  = "";

    open( SHAREFILE, "/jail/users/$owner/.shared/$share_conf_file" ) or die;

    while (<SHAREFILE>) {
        chomp($_);
        if ( $_ =~ /^\s*$/ ) {next;}
        # vynecham prazdne radky
        if ( $_ =~ /^user:$user/ ) {
            # preskocime uzivatele, ktereho chceme odstranit ze seznamu
	    next;
        } else {
	    # vytvorime novy seznam sdilejicich
	    $new_list .= $_ . "\n";
	}
    }
    close(SHAREFILE);

    #prekontrolujeme, zda nove vytvoreny seznam obsahuje nejake spolupracovniky
    #pokud ano, tak ho odsdilime, tedy smazeme konfiguracni soubor
    if ($new_list eq "") {
	unlink("/jail/users/$owner/.shared/$share_conf_file");
    } else {
	# pokud ne, otevreme znovu soubor tentokrat pro zapis a zapiseme do nej novy obsah
    	open( SHAREFILE, ">/jail/users/$owner/.shared/$share_conf_file" ) or die;
    	print SHAREFILE $new_list;
    	close(SHAREFILE);
    }
}
